
----------------------------------------------------------
-- Towers of Hanoi -- Second solution			--
----------------------------------------------------------

class   Pole

-----------------------------------------------------------
creation {ANY}
    make

-----------------------------------------------------------
feature {NONE}

-----------------------------------------------------------
    io : BASIC_IO
    pile : STACK[Ring]

-----------------------------------------------------------
feature {ANY}

-----------------------------------------------------------
    poleNo : INTEGER
    bigNum : INTEGER is 1000000

-----------------------------------------------------------
    rightPole : Pole
    leftPole : Pole

-----------------------------------------------------------
    make (n : INTEGER) is
	require
	    num_range : (n >= 1) and (n <= 3)
        do
            !!io
	    !!pile.make
	    poleNo := n
	    io.put_string ("Creating Pole ")
	    io.put_int (poleNo)
	    io.put_string ("%N")
        end

-----------------------------------------------------------
    linkPoles (left, right : Pole) is
        do
	    leftPole := left
	    rightPole := right
        end

-----------------------------------------------------------
    addRing (ring : Ring) is
	require
	    maintain_order : ring.size < topSize
        do
	    pile.add(ring)	-- push onto the stack
	    io.put_string("Moved Ring ")
	    io.put_int (ring.size)
	    io.put_string(" onto Pole ")
	    io.put_int (poleNo)
	    io.put_string ("%N")
        end

-----------------------------------------------------------
    moveRing is
	local
	    top : Ring
	do
	    if pile.empty
	    then
		emptyMove
	    else
		top := pile.item
		pile.remove
		top.move
	    end
	end

-----------------------------------------------------------
    topSize : INTEGER is
	do
	    if pile.empty
	    then
	    	Result := bigNum
	    else
	        Result := pile.item.size
	    end
	end

-----------------------------------------------------------
feature {NONE}

-----------------------------------------------------------
    emptyMove is
    -- default action to take when no rings left:
	do
	    rightPole.moveRing
	end

-----------------------------------------------------------
end -- class Pole

