
----------------------------------------------------------
-- Towers of Hanoi -- Second solution			--
----------------------------------------------------------

deferred class Ring

-----------------------------------------------------------
feature {NONE}

-----------------------------------------------------------
    io : BASIC_IO
    myPole : Pole

-----------------------------------------------------------
    -- generic procedure to output move
    doMove (direction : STRING) is
	do
	    io.put_string ("-- Ring ")
	    io.put_int (size)
	    io.put_string (" moves ")
	    io.put_string (direction)
	    io.put_string ("%N")
	end

-----------------------------------------------------------
    -- change to left or right pole
    changePole is deferred
	    -- for example:
	    -- doMove("left")
	    -- myPole := myPole.leftPole
	end

-----------------------------------------------------------
    -- select next pole to move a ring
    nextMove is deferred
	    -- for example:
	    -- myPole.leftPole.moveRing
	end

-----------------------------------------------------------
    make (s : INTEGER, p : Pole) is
	require
	    pos_size : s > 0		-- size must be positive
	    start_pole : p.poleNo = 1	-- must start on pole 1
        do
            !!io
	    size := s
	    myPole := p
	    io.put_string ("Creating Ring size = ")
	    io.put_int (size)
	    io.put_string ("%N")
        end

-----------------------------------------------------------
feature {ANY}

-----------------------------------------------------------
    size : INTEGER

-----------------------------------------------------------
    -- generic procedure to move
    -- NB: this will be called by the ring's current pole
    -- after it has been removed from the pile
    move is
	do
	    changePole			-- change my pole to new pole
	    myPole.addRing(current)	-- inform the new pole
	    nextMove		-- figure out which pole should move next
	end

-----------------------------------------------------------
end -- class Ring

