
----------------------------------------------------------
-- Towers of Hanoi -- Second solution			--
----------------------------------------------------------

-- this class accepts user input,
-- creates the poles and rings,
-- links the poles, stacks the rings onto the first pole,
-- and asks the start pole to start moving rings.

class   TOWERS

-----------------------------------------------------------
creation {ANY}
    make

-----------------------------------------------------------
feature {NONE}

-----------------------------------------------------------
    io : BASIC_IO
    p1, p2, p3 : Pole

-----------------------------------------------------------
    make is
	local
	    rings : INTEGER
        do
            !!io
	    io.put_string ("How many rings to make?%N")
	    io.get_int
	    rings := io.last_int
	    if (rings \\ 2) = 1
	    then
	        io.put_string ("Must be even%N")
	    elseif rings < 2
	    then
	        io.put_string ("Must be positive%N")
	    else
		makePoles
		makeRings(rings)
	    end
	end

-----------------------------------------------------------
    makePoles is
        do
	    io.put_string ("Creating Poles%N")
	    !!p1.make(1)
	    !!p2.make(2)
	    !!p3.make(3)
	    p1.linkPoles(p3,p2)
	    p2.linkPoles(p1,p3)
	    p3.linkPoles(p2,p1)
	end

-----------------------------------------------------------
    makeRings (n : INTEGER) is
	require
	    pos_rings : n > 0	-- create at least one ring!
	local
	    ringNo : INTEGER	-- the top ring is no. 1
	    left : LeftRing	-- be prepared to create any kind of ring
	    right : RightRing
	    top : TopRing
        do
	    io.put_string ("Creating Rings%N")
	    -- Make rings, starting from the LARGEST
	    from ringNo := n
	    until ringNo = 0
	    loop
		-- the bottom ring moves left, and the
		-- remaining rings alternate
		-- assuming an even number of rings,
		-- the top will move right
	        if ringNo = 1	-- the top ring
	        then
		    !!top.make(ringNo,p1)
		    p1.addRing(top)
	        elseif ((ringNo-n) \\ 2) = 0	-- even from bottom
	        then
		    !!left.make(ringNo,p1)
		    p1.addRing(left)
	        else				-- odd
		    !!right.make(ringNo,p1)
		    p1.addRing(right)
	        end
	        ringNo := ringNo - 1
	    end
	    io.put_string ("Towers Created%N")
	    p1.moveRing		-- start moving rings!
        end

-----------------------------------------------------------
end -- class TOWERS

