--------------------------------------------------------------------
--      Eiffel/S Window System
--
--      %M%
--      Version %I%
--      Copyright (C) by Jean-Guy Schneider <schneidr@iam.unibe.ch>
--
--      Created:       29.6.1995
--      Last Modified: %G%
--------------------------------------------------------------------
class BORDER  -- the border of the game
   
--------------------------------------------------------------------
creation {GAME}
   make
   
--------------------------------------------------------------------
feature {NONE}
   
   make (the_window : WINDOW, xres, yres, width : INTEGER,
	 the_color : STRING, squash : BOOLEAN) is
      require
	 non_void_window  : the_window /= Void
	 non_void_color   : the_color /= Void
	 valid_resolution : xres > 0 and then yres > 0
	 valid_width      : width > 0
      do 
	 !!wall1.make (the_window, 0, 0, xres, width, the_color, False)
	 !!wall2.make (the_window, 0, yres-width, xres, yres, the_color, False)
	 
	 if (squash) then
	    !!wall3.make (the_window, 0, 0, width, yres, the_color, False)
	 else
	    wall3 := wall2
	 end  -- if
      end  -- make
     
--------------------------------------------------------------------
feature {GAME}   
   
   in_border (x, y : INTEGER) : BOOLEAN is
	 -- is the point (x,y) inside the border?
      local
	 point_box : BOX
      do
	 !!point_box.make (x, y, x, y)
	 Result := point_box.intersect (wall1.bounding_box) or else
	           point_box.intersect (wall2.bounding_box) or else
		   point_box.intersect (wall3.bounding_box)
      end  -- inside

--------------------------------------------------------------------
feature {NONE}
   
   wall1 : RECTANGLE
   wall2 : RECTANGLE
   wall3 : RECTANGLE
   
--------------------------------------------------------------------
invariant
   non_void_walls : wall1 /= Void and then
                    wall2 /= Void and then
		    wall3 /= Void
		    
--------------------------------------------------------------------
end  -- class BORDER
