--------------------------------------------------------------------
--      Eiffel/S Window System
--
--      %M%
--      Version %I%
--      Copyright (C) by Jean-Guy Schneider <schneidr@iam.unibe.ch>
--
--      Created:       29.6.1995
--      Last Modified: %G%
--------------------------------------------------------------------
class GAME  -- simple Squash game
   
--------------------------------------------------------------------
creation {ANY}
   make
   
--------------------------------------------------------------------
feature {NONE}
   
   make is
      do
	 -- Init the game
	 x_res := 600
	 y_res := 400
	 width := 30
	 
	 !!the_window.make ("Squash Game", x_res, y_res, "white")
	 !!the_border.make (the_window, x_res-width, y_res, width,
			    "black", True)
	 !!the_ball.make (the_window, Current, x_res, y_res, 15, "black")
	 !!the_player.make (the_window, x_res, y_res, width, "black")
	 
	 -- Start the game
	 the_window.wait
	 play
	 
	 -- game over
	 end_of_game
	 the_window.destroy_window
      end  -- make
   
--------------------------------------------------------------------
feature {BALL}   
   
   bounce (x, y : INTEGER) : BOOLEAN is
      do
	 Result := the_border.in_border (x, y) or else
	           the_player.bounce (x, y)
      end  -- bounce

--------------------------------------------------------------------
feature {NONE}   
   
   the_window : WINDOW
   the_border : BORDER
   the_ball   : BALL
   the_player : PLAYER
   
   x_res, y_res : INTEGER     -- resolution of the game
   width        : INTEGER     -- width of border and player
   
--------------------------------------------------------------------
   play is
      do
	 from
	 until
	    out_of_game
	 loop
	    the_ball.move
	    the_player.move
	 end  -- loop
      end  -- play
 
--------------------------------------------------------------------
   out_of_game : BOOLEAN is
	 -- is the ball out of the game?
      do
	 Result := not the_ball.in_game (x_res, y_res)
      end  -- out_of_game
   
--------------------------------------------------------------------
   end_of_game is
      local
	 end_text : TEXT
      do
	 the_ball.remove
	 !!end_text.make (the_window, "GAME OVER!", (x_res/2) - 50,
			  y_res/2, "red")
	 the_window.wait
      end  -- end_of_game

--------------------------------------------------------------------
end  -- class GAME
